U-BOOT-UPDATE(8)

NAME
u-boot-update - program to generate u-boot menu files

SYNOPSIS
u-boot-update

DESCRIPTION
u-boot-update is a tool used to generate the menu files used by the U-BOOT bootloader. Options can be configured in /etc/default/u-boot or by adding configuration fragment files to /usr/share/u-boot-menu/conf.d/ (those take precedence over /etc/default/u-boot) and/or to /etc/u-boot-menu/conf.d/ (those take precedence over the 2 aforementioned locations).

In order to avoid situations where the system might be rendered unbootable by a package removal, other packages and downstream distributions MUST NOT edit or modify files under /etc as those are meant for use by end-users only. Instead, it is mandated for such packages to install their config fragments ONLY under /usr/share/u-boot-menu/conf.d/.

For each <version> of linux kernel installed, menu items for each of <U_BOOT_ALTERNATIVES> are generated for the first valid entry among these:

•   fdt <U_BOOT_FDT_DIR><version>/<U_BOOT_FDT>

•   fdtdir <U_BOOT_FDT_DIR><version>/

•   fdt /<U_BOOT_FDT>

•   fdt /dtb-<version>

Paths without <U_BOOT_FDT_DIR> are considered only when <U_BOOT_FDT_DIR> is left at its default value.

When root (/) and boot (/boot) are mounted on separate filesystems, paths are examined with /boot prepended (i.e. variables should be defined without it).

OPTIONS

U_BOOT_UPDATE="true|false"
    This variable specifies if u-boot-update is allowed to modify the configuration files in /boot/extlinux. Values are either 'true' or 'false', default is 'true'.

U_BOOT_ALTERNATIVES="default recovery"
    This variable specifies which entries u-boot-update is populating. Values are 'default', 'recovery', 'live', default is 'default recovery'.

U_BOOT_DEFAULT="l0"
    This variable specifies the default entry to boot. The name of an entry consists of two or three characters. Linux kernel images start with the letter 'l', followed by an integer started by '0' for the first kernel version (which is numerically the highest one in case kernel images of more than one linux version are installed) and, optionally, the mode (r for rescue mode, l for live mode). Memdisk entries start with the letter 'm', followed by an integer, no optional modes available. The default is 'l0'.

U_BOOT_ENTRIES="all"
    This variables specifies how many kernel versions should be used to populate the boot configuration. Value is an integer starting with 1, or 'all' to populate for all kernels, default is 'all'.

U_BOOT_MENU_LABEL="Debian GNU/Linux, kernel"
    This variable specifies the text that is used as a description in the boot menu. Value is an arbitrary string. If not specified, PRETTY_NAME from /etc/os-release is used. Otherwise, it defaults to 'Debian GNU/Linux, kernel'.

U_BOOT_PARAMETERS="ro quiet"
    This variable specifies additional boot parameters that are appended to each kernel entry. Value is an arbitrary string, default is the contents of /etc/kernel/cmdline, or 'ro quiet' (except for recovery entries, where quiet is avoided) if this file is not present or empty.

U_BOOT_ROOT="root=DEVICE"
    This variable specifies the root partition. It is automatically extracted from /etc/fstab. U-BOOT supports both devices and UUIDs.

U_BOOT_TIMEOUT="50"
    This variable specifies the time that U-BOOT should wait for user input during boot. Values are in decisecond greater than 0 (e.g. '10' for a 1 second timeout), 0 specifies to wait forever. The default is 50.

U_BOOT_FDT_DIR="/usr/lib/linux-image-"
    This variable specifies the unversioned stem of paths where U-BOOT should look for the flattened device tree binaries. Default is '/usr/lib/linux-image-'. When U_BOOT_SYNC_DTBS is true and u-boot-update detects /boot is on a separate partition, the default value is then '/dtb-'.

U_BOOT_FDT="device-tree.dtb"
    This variable specifies filename or trailing part of path for a single device tree binary. Default is 'device-tree.dtb'.

U_BOOT_FDT_OVERLAYS_DIR="/boot/dtbo"
    This variable specifies the unversioned stem of paths where U-BOOT should look for the flattened device tree overlays binaries. Default is '/boot/dtbo/'.

U_BOOT_FDT_OVERLAYS="device-tree.dtbo"
    This variable specifies filenames or trailing part of path for device tree overlay binaries. Default is not set.

U_BOOT_INITRD="initrd.img"
    This variable specifies the unversioned stem of initramfs filename. If versioned filename exists (e.g. 'initrd.img-5.10.0-8-armmp-lpae') then this filename set as option 'initrd', otherwise if unversioned filename exists (e.g. 'initrd.img) then that is set as option 'initrd', otherwise option 'initrd' is not set. Default is 'initrd.img'.

U_BOOT_SYNC_DTBS="true|false"
    This variable specifies if u-boot-update should automatically attempt to copy device tree binaries to /boot in case it is on a different partition than /. Values are either 'true' or 'false', default is 'false'.

FILES
/etc/default/u-boot /usr/share/u-boot-menu/conf.d/ /etc/u-boot-menu/conf.d/

HOMEPAGE
More information about U-BOOT can be found at <http://www.denx.de/wiki/U-Boot>.

u-boot-update and this manual page was written by Daniel Baumann <daniel.baumann@progress-technologies.net> for extlinux. Riku Voipio <riku.voipio@linaro.org> updated them for u-boot. Jonas Smedegaard <dr@jones.dk> updated misc. later changes.